<?php
ignore_user_abort();
ini_set('max_execution_time', 86400);

include('functions.api.php');

if ($argv[1]) {
    foreach ($argv as $arg) {
        $e = explode("=", $arg);
        if (count($e) == 2) {
            $_POST[$e[0]] = $e[1];
        } else {
            $_POST[$e[0]] = 0;
        }
    }
}

require_once "../../db.php";

if (isset($_POST['formSubmit']) || $argv[1]) {

    $_POST = array_map_array('trim', $_POST);

    if ($_POST['q'] == '') {
        setMessage('"Search String" is required!', 'error');
    }
    if (!is_numeric($_POST['start_index'])) {
        setMessage('"Pages" must be positive integer value!', 'error');
    }
    if ($_POST['submitter'] == '') {
        setMessage('"Submitter" is required!', 'error');
    }
    if ($_POST['paysite'] == '') {
        setMessage('"Paysite" is required!', 'error');
    }
    if ($_POST['action'] == '') {
        setMessage('"Action" is required!', 'error');
    }

    if (!getMessages(false, 'error')) {

        $getUser = dbRow("SELECT `record_num` FROM `users` WHERE `username` = '" . mysqli_real_escape_string($dblink, $_POST['submitter']) . "'");
        $_POST['submitter'] = is_array($getUser) ? $getUser['record_num'] : 0;

        if ($_POST['action'] == 'embed') {
            $videos = getTube8Json($_POST['q'], $_POST['start_index']);
            if (isset($videos['error'])) {
                setMessage("Tube8 Response: <b>$videos[error]</b>", 'error');
            } else {
                foreach ($videos as $arr) {

                    $bad = array("\r", "\n", "\t");
                    $arr = mysql_real_escape_array($arr);
                    $arr['embed'] = trim(str_replace($bad, "", $arr['embed']));
                    $check = dbQuery("SELECT record_num FROM content WHERE embed LIKE '%$arr[embed]%'",false);
                    if (count($check) < 1) {

                        if (dbQuery("INSERT INTO content (length, title, description, keywords, date_added, approved, embed, submitter, paysite) VALUES ('$arr[lengthsec]','$arr[title]', '$arr[title]', '$arr[tags]', NOW(), 2, '$arr[embed]','$_POST[submitter]', '$_POST[paysite]')")) {
                            $insert = mysqli_insert_id($dbconn);
                            $file = file_get_contents($arr[thumb]);
                            @mkdir($thumb_path . '/embedded');
                            file_put_contents($thumb_path . '/embedded/' . $insert . '.jpg', $file);
                            dbQuery("INSERT INTO content_views (content,views) VALUES ('$insert',0)");
                            if (filesize($thumb_path . '/embedded/' . $insert . '.jpg') > 48) {
                                $counter++;
								$thisThumb = $thumb_path . '/embedded/' . $insert . '.jpg';
								if(cephUploadObject($thisThumb,str_replace("$basepath/media/","",$thisThumb))) {
									if($ceph_delete_local) { 
										@unlink($thisThumb); 
									}
								}
                            } else {
                                dbQuery("DELETE FROM content WHERE record_num = '$insert'");
                                dbQuery("DELETE FROM content_views WHERE record_num = '$insert'");
                                $errors++;
                            }
                            if ($arr['tags']) {
                                $parray = explode(',', $arr['tags']);
                                foreach ($parray as $p) {
                                    $p = trim($p);
                                    $rresult = dbQuery("SELECT record_num FROM niches WHERE name LIKE '$p' OR (csv_match != '' AND csv_match LIKE '%$p%')",false);
                                    if (count($rresult) > 0) {
                                        $rrow = $rresult[0];
                                        dbQuery("INSERT INTO content_niches (niche, content) VALUES ('$rrow[record_num]', '$insert')");
                                        unset($rrow, $rresult);
                                    }
                                }
                            }
                        }
                    }
                }
            }
            if ($counter > 0) {
                setMessage("$counter videos were added to your publish queue");
            } else {
                setMessage("No videos were added to your publish queue", 'error');
            }
        } else {
            $videos = getTube8Json($_POST['q'], $_POST['start_index']);
            if (isset($videos['error'])) {
                setMessage("Tube8 Response: <b>$videos[error]</b>", 'error');
            } else {
                foreach ($videos as $i) {
                    if ($i['url']) {
                        $i = mysql_real_escape_array($i);
                        $data = mysqli_real_escape_string($dblink,json_encode($i));
                        if (dbQuery("INSERT INTO scraper_import SET url = '$i[url]', user = '$_POST[submitter]', paysite = '$_POST[paysite]', data = '$data'")) {
                            $counter++;
                        }
                    }
                }
            }
            if ($counter > 0) {
                setMessage("$counter videos were added to the tube scraper queue");
            } else {
                setMessage("No videos were added to the tube scraper queue", 'error');
            }
        }

        if ($argv[1]) {
            echo getMessages();
            exit();
        } else {
            header("Location: $_SERVER[REQUEST_URI]");
            exit();
        }
    }
}

entities_walk($_POST);

?>

<? if (!$argv[1]) { ?>
    <? require "../../header.php"; ?>
<? } ?>

<div class="content-page">
    <div class="header-area">

        <div class="breadcrumbs">  
            <a href="index.php">Admin Home</a>          
            <span><a href="tube8.php">Tube8 API Import</a></span>  
        </div>
    </div>

    <div class="content-outer">  
        <h2>Tube8<strong>API</strong></h2>

        <div class="notification info">You can use this script to import videos from Tube8 in bulk. Enter a search term below <strong>(a search is mandatory on tube8 api)</strong>. For pages, tube delivers 31 videos per page so multiply the pages by the number of videos you want. If you select embed, the videos will be added to the publish queue immediately. If you select download, the videos will be added to the tube scraper queue (which must be executed manually)</div>

        <div class="notification info"><strong>This script can also be executed from cron by using the following command line in crontab to run at whatever interval you like:</strong><br />
            <em>cd <? echo $basepath; ?>/admin/modules/tubeapi/; <? echo $php_path; ?> tube8.php paysite=X submitter=Y start_index=Z action=embed q="Required Search String"</em><Br />
            (X is id number of paysite, Y is id number of user, Z is number of pages to grab)
        </div>

        <? echo getMessages(); ?>

        <div class="content-inner">

            <form method="POST" action="" enctype="multipart/form-data" class="form" novalidate autocomplete="off">
                <table class="pagetable">
                    <tbody>
                        <tr>
                            <td>Search String</td>
                            <td><input name="q" type="text" value="<? echo $_POST['q']; ?>" required /></td>
                        </tr>
                        <tr>
                            <td>Pages</td>
                            <td><input name="start_index" type="number" value="<? echo is_numeric($_POST['start_index']) ? (int) $_POST['start_index'] : 1; ?>" min="1" class="tiny" required /></td>
                        </tr>
                        <tr>
                            <td>Action</td>
                            <td>
                                <select name="action" required>
                                    <option value="embed"<? echo ($_POST['action'] == 'embed') ? ' selected' : ''; ?>>Embed</option>
                                    <option value="download"<? echo ($_POST['action'] == 'download') ? ' selected' : ''; ?>>Add To Scraper Queue</option>
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td>Video Submitter:</td>
                            <td>
                                <input type="text" name="submitter" id="contentAutocomplete" value="<? echo $_POST['submitter']; ?>" placeholder="Start typing username..." required />
                                <script type="text/javascript">
                                    $(document).ready(function () {
                                        $("#contentAutocomplete").autocomplete({
                                            source: basehttp + "/admin/search_content.php?type=2",
                                            minLength: 2
                                        });
                                    });
                                </script>
                            </td>
                        </tr>
                        <tr>
                            <td>Paysite:</td>
                            <td>
                                <select name="paysite" required>
                                    <option value=""> - select paysite - </option>
                                    <? $rresult = dbQuery("SELECT * FROM `paysites` ORDER BY `name`", false); ?>
                                    <? foreach ($rresult as $rrow) { ?>
                                        <option<? echo ($_POST['paysite'] == $rrow['record_num']) ? ' selected' : ''; ?> value="<? echo $rrow['record_num']; ?>"><? echo $rrow['name']; ?></option>
                                    <? } ?>
                                </select>
                            </td>
                        </tr>
                        <tr class="item submit">
                            <td colspan="2">
                                <input type="hidden" name="formSubmit" value="1" />
                                <button type="submit" class="btn action-save">Submit</button>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </form>
        </div>
    </div>
</div>
<? require "../../footer.php"; ?>